package org.fipro.tycho.resources.test.core.file;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertTrue;

import java.net.URL;
import java.util.List;

import org.junit.Test;

public class FileHandlerTest {

	@Test
	public void testReadFileFromPlugin() throws Exception {
		List<String> result = FileHandler.readFile(this.getClass().getResourceAsStream("../resources/test.txt"));
		assertEquals(4, result.size());
	}
	
	@Test
	public void testReadFileFromPluginTestResources() throws Exception {
		List<String> result = FileHandler.readFile(this.getClass().getResourceAsStream("/test_resource.txt"));
		assertEquals(5, result.size());
	}
	
	@Test
	public void testAccessFileFromPlugin() throws Exception {
		URL fileURL = this.getClass().getResource("../resources/test.txt");
		assertTrue("URL does not start with file: " + fileURL, fileURL.toString().startsWith("file:/"));
	}
	
	@Test
	public void testAccessFileFromPluginTestResources() throws Exception {
		URL fileURL = this.getClass().getResource("/test_resource.txt");
		assertTrue("URL does not start with file: " + fileURL, fileURL.toString().startsWith("file:/"));
	}
	
}
