package org.fipro.tycho.resources.test.core.file;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.net.URISyntaxException;
import java.net.URL;
import java.nio.charset.Charset;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.ArrayList;
import java.util.List;

public class FileHandler {

	public static List<String> readFile(URL file) throws URISyntaxException, IOException {
		List<String> result = new ArrayList<>();
		
		Path myPath = Paths.get(file.toURI());
		
		if (!Files.exists(myPath)) {
			throw new IllegalArgumentException("The specified file does not exist!");
		}
		
		try(BufferedReader reader = Files.newBufferedReader(myPath, Charset.defaultCharset())) {
			String input = "";
			while ((input = reader.readLine()) != null) {
				result.add(input);
			}
		}
		
		return result;
	}

	public static List<String> readFile(String file) throws URISyntaxException, IOException {
		List<String> result = new ArrayList<>();
		
		Path myPath = Paths.get(file);
		
		if (!Files.exists(myPath)) {
			throw new IllegalArgumentException("The specified file does not exist!");
		}
		
		try(BufferedReader reader = Files.newBufferedReader(myPath, Charset.defaultCharset())) {
			String input = "";
			while ((input = reader.readLine()) != null) {
				result.add(input);
			}
		}
		
		return result;
	}

	public static List<String> readFile(InputStream file) throws URISyntaxException, IOException {
		List<String> result = new ArrayList<>();
		
		try(BufferedReader reader = new BufferedReader(new InputStreamReader(file))) {
			String input = "";
			while ((input = reader.readLine()) != null) {
				result.add(input);
			}
		}
		
		return result;
	}

	
	public static void writeFile(URL file, List<String> inputs) throws URISyntaxException, IOException {
		Path myPath = Paths.get(file.toURI());
		try (BufferedWriter writer = Files.newBufferedWriter(myPath, Charset.defaultCharset())) {
			for (String out : inputs) {
				writer.write(out);
				writer.newLine();
			}
		}
	}
}
